{$IFDEF Ver70}
{ Compiler directives for Turbo Pascal 7.0 }
{$A+,B-,D+,E-,F-,I+,L+,N-,O-,P+,Q-,R-,S-,T-,V-,X+}
{$IFDEF DPMI} {$G+} {$ELSE} {$G-} {$ENDIF}
{$M 16384,0,655360}
{$ENDIF}

{$IFDEF Ver60}
{ Compiler directives for Turbo Pascal 6.0 }
{$A+,B-,D+,E-,F-,G-,I+,L+,N-,O-,R-,S-,V-,X+}
{$M 16384,0,655360}
{$ENDIF}

program SIPS; { Sprite Operations Per Minute }

{ FastVGA v1.0, (C)1993 by Tal Cohen }

uses Dos,Crt,FastVGA,TestSprite;

var Spr,Spr1,Spr2:Sprite;
    H,sH,M,sM,S,sS,S100,sS100,Count:Word;
    Time:Real;
    MvX,MvY:ShortInt;

procedure TitleLine;
 begin
  TextAttr:=Cyan;
  Write ('Fast');
  TextAttr:=LightCyan;
  Write ('VGA');
  TextAttr:=LightGray;
  WriteLn (' v1.0: Sprite Instructions Per Second (SIPS) Test');
  WriteLn;
 end;

begin
 TextMode (Co80);
 TitleLine;
 WriteLn ('While computer power is normally measured in MIPS (Million Instructions Per');
 WriteLn ('Second), FastVGA''s graphical preformance is measured in SIPS: Sprite');
 WriteLn ('Insturctions Per Second. The SIPS rate of a machine will improve if the machine');
 WriteLn ('is faster; but, more to the point, SIPS can show you how much faster the');
 WriteLn ('registered version of FastVGA is. The registered FastVGA uses more optimized');
 WriteLn ('algorithms and tighter assembler code, and when detecting a 386SX or better');
 WriteLn ('CPU, it even uses 32-Bit instructions for really amazing speed results.');
 WriteLn;
 WriteLn ('Before the test begins, the screen might look frozen for a few seconds. This');
 WriteLn ('time is spent syncronizing with the system clock.');
 WriteLn;
 WriteLn ('For best results, run this program from the command line, rather then Turbo');
 WriteLn ('Pascal''s IDE.');
 WriteLn;
 WriteLn ('The complete SIPS test takes at least a minute.');
 WriteLn;
 Write ('Press any key to continue ... ');
 ReadKey;
 ClrScr;
 TitleLine;
 Write ('NOTE ON EXECUTION: The program detected a ');
 if Test8086<2 then
  WriteLn ('80286 or lower CPU.')
 else
  WriteLn ('80386SX or better CPU.');
 if FastVGARegistered then
  begin
   if Test8086<2 then
    WriteLn ('Fast instructions are used, but not 32-Bit ones.')
   else
    WriteLn ('Fully optimized 32-Bit instructions are used.');
  end
 else
  begin
   if Test8086<2 then
    begin
     WriteLn ('This is not a registered copy of FastVGA, so non-optimized instructions are');
     WriteLn ('used.');
    end
   else
    begin
     WriteLn ('32-Bit instructions are disabled, however, and non-optimized ones are used,');
     WriteLn ('because this is not a registered copy of FastVGA.');
    end;
   WriteLn ('For the same reason, the program might crash, displaying a "Register FastVGA"');
   WriteLn ('message. When this happens, simply re-run the program.');
  end;
 WriteLn;
 Write ('Press any key to begin the test ... ');
 ReadKey;
 AssignSprite (@Spr,@TestSpriteBMP);
 AssignSprite (@Spr1,@TestSpriteBMP);
 AssignSprite (@Spr2,@TestSpriteBMP);
 GoVGA256;
 Count:=0;
 MvX:=1;
 MvY:=1;
 PutSprite (@Spr1,0,0);
 PutSprite (@Spr2,100,100);
 repeat
  GetTime (sH,sM,sS,sS100);
 until (sM<>59) and (sS100=0);
 repeat
  PutSprite (@Spr,260,100);         { Operation 01 }
  ReadyMoveSprite (@Spr1);          { Operation 02 }
  MoveSprite (@Spr,0,2);            { Operation 03 }
  ReadyMoveSprite (@Spr2);          { Operation 04 }
  MoveSprite (@Spr,2,0);            { Operation 05 }
  SetMoveSprite (@Spr2,-MvX,-MvY);  { Operation 06 }
  MoveSprite (@Spr,0,-2);           { Operation 07 }
  SetMoveSprite (@Spr1,MvX,MvY);    { Operation 08 }
  MoveSprite (@Spr,-2,0);           { Operation 09 }
  GoMoveSprites;                    { Operation 10 }
  RemoveSprite (@Spr);              { Operation 11 }
  GetTime (H,M,S,S100);
  Inc (Count);
  if Count mod 100=0 then
   begin
    MvX:=-MvX;
    MvY:=-MvY;
   end;
 until (M>sM) and (S=sS);
 TextMode (Co80);
 Time:=(M-sM)+S100/6000; { Test time in minutes }
 TitleLine;
 Write ('Test completed. SIPS score for this machine: ');
 TextAttr:=White;
 Write (((11*Count/Time)/60):0:1); { The loop did 11 sprite operations }
 TextAttr:=LightGray;
 WriteLn; WriteLn;
 WriteLn ('For comparison, here are some other SIPS results:');
 WriteLn;
 WriteLn ('Machine               CPU           Cache   VGA Card            SIPS (Reg''d)');
 WriteLn ('                                         ');
 WriteLn ('Phenix PXT            8088/4.77MHz  None    Realtek VGA          14.0  (22.1)');
 WriteLn ('MLL PC-10             8088/10MHz    None    Realtek VGA          29.4  (49.2)');
 WriteLn ('IBM PS/2 Model 25-G36 80286/10MHz   None    On-board IBM VGA     39.5  (71.5)');
 WriteLn ('Clone 386SX/25        80386SX/25MHz None    Trident 8900        121.1 (235.4)');
 WriteLn ('Chicony 386DX-33      80386DX/33MHz 64KB    Trident 8900C       151.3 (331.3)');
 WriteLn ('MHD Systems 433       i486DX/33MHz  256KB   Tseng ET4000        266.4 (582.2)');
 WriteLn ('410M i486             i486DX/50MHz  256KB   Tseng ET4000        338.8 (725.1)');
 WriteLn;
 WriteLn ('The number in parenthesis shows the SIPS result when using the registered');
 Write ('FastVGA on the same machine. As you can see, the improvement is ');
 TextAttr:=White; Write ('over 90%'); TextAttr:=LightGray;
 WriteLn (' on');
 WriteLn ('average.');
 WriteLn;
 WriteLn ('I guess we''ll have to wait for Intel''s 250MHz Hexium to measure test results in');
 WriteLn ('Mega-SIPS ...');
end.
