{$IFDEF Ver70}
{ Compiler directives for Turbo Pascal 7.0 }
{$A+,B-,D+,E-,F-,I+,L+,N-,O-,P+,Q-,R-,S-,T-,V-,X+}
{$IFDEF DPMI} {$G+} {$ELSE} {$G-} {$ENDIF}
{$M 16384,0,655360}
{$ENDIF}

{$IFDEF Ver60}
{ Compiler directives for Turbo Pascal 6.0 }
{$A+,B-,D+,E-,F-,G-,I+,L+,N-,O-,R-,S-,V-,X+}
{$M 16384,0,655360}
{$ENDIF}

program TABDemo;

{ FastVGA v1.0, (C)1993 by Tal Cohen }

uses FastVGA,FastFonts,PCXUnit,Crt,TABPCX;

const Trail = 10;

type RGBType = array [RGBRed..RGBBlue] of Byte;
     RGB10 = array [1..Trail] of RGBType;
     RGB10Ptr = ^RGB10;

var Er,i,Pass:Byte;
    a,b:Word;
    P,Black:PaletteType;
    Fade,DoneFade,Done,Flip:Boolean;
    OldRGB:RGB10;
    C:Word;
    FontColor,BitVal,LineVal:Byte;
    WaitVal:Word;
    TextColors:RGB10;

const ScrlText:array [1..12] of String[50] =
 ('        ~1The Ace Base:~2 The best ~3free~2 BBS in',
  ' the Middle East                 Nearly ~31GB~2 of',
  ' files on-line (with a ~4CD-ROM~2)                ',
  ' ~5FidoNet~2 NetMail: 2:401/112, with free access ',
  'to ~6UltiNet~2, ~7TechNet~2, and ~8EZNet~2 EchoMai',
  'l and NetMail            Line 1: (+972)-53-358599,',
  ' 14,400 BPS, V.32, V.42BIS       Line 2: (+972)-53',
  '-358899, 2,400 BPS, MNP 5, Ringdown to Line 1     ',
  '           ~1The Ace Base~2 is the support BBS for',
  ' ~9Fast~4VGA~2 and many other fine products       ',
  '         ~1The Ace Base:~2 Boosting up the Limits!',
  '                                                  ');

procedure ScrollLine;
 begin
  VSync;
  ScrollLeft (0,184,319,199);

  VGAColor:=0;
  VLine (319,184,199);
  VGAColor:=FontColor;

  if BitVal<>0 then Font16VLine (319,184,ScrlText[LineVal][C],BitVal);

  if BitVal=8 then
   begin
    BitVal:=0;
    Inc(C);

    if ScrlText[LineVal][C]='~' then
     begin
      Inc(C);
      FontColor:=Byte(ScrlText[LineVal][C])-Byte('0')+100;
      Inc(C);
     end;
    if C>50 then
     begin
      C:=1;
      Inc (LineVal);
      if LineVal>12 then
       LineVal:=1;
     end;
   end
  else
   Inc(BitVal);                    { Just a new line in the same char }
 end;

procedure WriteFast;
 begin
  TextAttr:=Cyan;
  Write ('Fast');
  TextAttr:=LightCyan;
  Write ('VGA');
  TextAttr:=LightGray;
 end;

begin
 if TestVGA=0 then
  begin
   WriteLn ('This program requires a VGA/MCGA card.');
   Halt;
  end;
 Randomize;
 GoVGA256;
 Font16Init;
 MemLoadPCXPage2 (@TABDemoPCX,TABPCXSize,Black,Er);
 FillChar (P,300,0);
 Move (Black[100],P[100],30);
 TextColors:=RGB10Ptr(@P[100])^;
 SetActivePalette (P,0,255);
 CopyBlockFromPage2 (129,51,175,70);
 for i:=0 to Trail-2 do
  begin
   P[66+i][RGBRed]:=i*5+17;
   b:=9-i; if b>7 then b:=7;
   P[66+i][RGBGreen]:=b;
   P[66+i][RGBBlue]:=63-i*7;
  end;
 P[65+Trail][RGBRed]:=63;
 P[65+Trail][RGBGreen]:=63;
 P[65+Trail][RGBBlue]:=10;
 a:=5;
 Fade:=False;
 Done:=False;
 DoneFade:=False;
 Pass:=1;
 FontColor:=102;
 LineVal:=1; BitVal:=0; C:=1;
 WaitVal:=30;
 repeat
  OldRGB:=RGB10Ptr(@P[a])^;
  Move (P[66],P[a],SizeOf(RGB10));
  SetActivePalette (P,a-1,a+Trail);
  RGB10Ptr(@P[a])^:=OldRGB;
  Inc (a);
  if (a=65) then
   begin
    a:=5;
    Done:=DoneFade;
    Inc (Pass);
    case Pass of
     2:CopyBlockFromPage2 (8,85,134,139);
     3:CopyBlockFromPage2 (159,85,314,139);
    end;
   end;
  if Pass>2 then
   begin
    Flip:=not Flip;
    if Flip then
     PullToPalette (P,Black,5,65,DoneFade);
   end;
  if KeyPressed then DoneFade:=True;
  ScrollLine;
 until Done;
 Fade:=False;
 Done:=False;
 DoneFade:=False;
 FillChar (Black,SizeOf(Black),0);
 RGB10Ptr(@P[100])^:=TextColors;
 repeat
  OldRGB:=RGB10Ptr(@P[a])^;
  Move (P[66],P[a],SizeOf(RGB10));
  SetActivePalette (P,a-1,a+10);
  RGB10Ptr(@P[a])^:=OldRGB;
  Inc (a);
  if (a=65) then
   begin
    a:=5;
    Done:=DoneFade;
   end;
  if KeyPressed then Fade:=True;
  if Fade then
   begin
    Flip:=not Flip;
    if Flip then
     begin
      PullToPalette (P,Black,100,109,DoneFade);
      PullToPalette (P,Black,5,65,DoneFade);
      SetActivePalette (P,100,109);
     end;
   end;
  ScrollLine;
 until Done;
 Font16Done;
 TextMode (Co80);
 TextAttr:=LightGray;
 Write ('Created using ');
 WriteFast;
 WriteLn (' v1.0 and Turbo Pascal. (C)1993 by Tal Cohen');
 WriteLn;
 Write ('Call ');
 TextAttr:=White;
 Write ('THE ACE BASE');
 TextAttr:=LightGray;
 WriteLn (' BBS for the latest games and programs, including');
 Write ('the latest updates of ');
 WriteFast;
 WriteLn (' and all my other software products!');
 WriteLn;
 WriteLn ('THE ACE BASE is active 24 hours with two lines:');
 WriteLn;
 WriteLn ('Line 1: +972-53-358599 (14,400 BPS, V.32, V.42bis)');
 WriteLn ('Line 2: +972-53-358899 (2,400 BPS, MNP 5)');
 WriteLn;
 WriteFast;
 WriteLn ('''s latest version can be FREQ''ed from THE ACE BASE, by');
 WriteLn ('using the Magic Name "FASTVGA". The FidoNet Address is 2:401/112,');
 WriteLn ('the TechNet (RC) address is 111:40/0, and the EZNet address is');
 WriteLn ('255:3110/103.');
 WriteLn;
 WriteLn ('PLEASE NOTE: A more complete, visually improved version of this demo,');
 Write ('             complete with ');
 TextAttr:=White;
 Write ('music');
 TextAttr:=LightGray;
 WriteLn (', for either Sound-Blaster or the PC-');
 WriteLn ('             speaker, is available for download from The Ace Base.');
 WriteLn;
end.
